from cloudinit import log as logging

import os
from subprocess import call

LOG = logging.getLogger(__name__)

PROC_IPV6_PATH = "/proc/sys/net/ipv6/"
ENABLE_IPV6_CMD = "/sbin/disable_ipv6 off 2>&1 1>/dev/null"
DISABLE_IPV6_CMD = "/sbin/disable_ipv6 on 2>&1 1>/dev/null"

def handle(name, cfg, cloud, log, _args):
    ret_value = None

    ret_value = cloud.datasource.get_enable_ipv6_conf()
    LOG.info(("Skipping module named %s,"
              " ipv6 datasource is %s"), name, ret_value)

    if not os.path.exists(PROC_IPV6_PATH):
        LOG.debug(("Skipping module named %s,"
                   " the vm is already disabled ipv6, not found path=/proc/sys/net/ipv6/ "), name)
        return

    if ret_value == True:
        try:
            if call(ENABLE_IPV6_CMD, shell=True):
                LOG.debug(("Skipping module named %s,"
                           " Fail: config enable ipv6, shell cmd is"), name, ENABLE_IPV6_CMD)
                return
            else:
                LOG.debug(("Skipping module named %s,"
                           " OK: config enable ipv6, shell cmd is"), name, ENABLE_IPV6_CMD)
        except Exception as ex:
            LOG.debug(("Skipping module named %s,"
                       " config enable ipv6 except, The except is %s "), name, repr(ex))
            return
    elif ret_value == False:
        try:
            if call(DISABLE_IPV6_CMD, shell=True):
                LOG.debug(("Skipping module named %s,"
                           " Fail: config disable ipv6, shell cmd is"), name, DISABLE_IPV6_CMD)
                return
            else:
                LOG.debug(("Skipping module named %s,"
                           " OK: config disable ipv6, shell cmd is"), name, DISABLE_IPV6_CMD)
        except Exception as ex:
            LOG.debug(("Skipping module named %s,"
                       " config disable ipv6 except, The except is %s "), name, repr(ex))
            return
    else:
        LOG.debug(("Skipping module named %s,"
                   " use_ipv6 datasource (must be bool value True or False) is unknown value, this is %s."), name, ret_value)
        return
